## vidalia 0.2.21

=== CMakeLists.txt ===
##
##  $Id$
##
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia,
##  including this file, may be copied, modified, propagated, or distributed
##  except according to the terms described in the LICENSE file.
##


set(VER_MAJOR   "0")
set(VER_MINOR   "2")
set(VER_PATCH   "21")
set(VERSION     "${VER_MAJOR}.${VER_MINOR}.${VER_PATCH}")
message(STATUS  "Configuring Vidalia ${VERSION}")
project(Vidalia)

## Specify the minimim required CMake version
cmake_minimum_required(VERSION 2.4.7)
if (COMMAND cmake_policy)
  # Force CMake 2.4 compatibility for handling linker search paths
  cmake_policy(SET CMP0003 OLD)
endif(COMMAND cmake_policy)

## We declare this option here, because it determines the minimum
## required Qt version
option(USE_MARBLE "Enable the KDE Marble-based map widget." OFF)

## Specify the minimum version of Qt required
set(QT_MIN_VERSION    "4.3.0")

## Specify the Qt libraries used
include(FindQt4)
find_package(Qt4 REQUIRED)
set(QT_USE_QTNETWORK  true)
set(QT_USE_QTXML      true)
if (USE_MARBLE)
  set(QT_USE_QTSVG    true)
  set(QT_USE_QTWEBKIT true)
  set(QT_USE_QTSCRIPT true)
  set(QT_USE_QTDBUS   true)
endif(USE_MARBLE)
include(${QT_USE_FILE})
include(${CMAKE_SOURCE_DIR}/cmake/VidaliaMacros.cmake)
include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckTypeSize)
include(CheckFunctionExists)
if (WIN32)
  include(${CMAKE_SOURCE_DIR}/cmake/FindWiX.cmake)
endif(WIN32)

if(MSVC_IDE)
    set(CMAKE_SUPPRESS_REGENERATION TRUE)
    set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
    set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
endif(MSVC_IDE)

## Define Vidalia-specific CMake options
if (APPLE)
  option(OSX_TIGER_COMPAT "Build an OS X 10.4 Compatible Vidalia." OFF)
  if (OSX_TIGER_COMPAT)
    set(CMAKE_EXE_LINKER_FLAGS "-mmacosx-version-min=10.4"
      CACHE STRING "Flags used by the linker." FORCE)
    set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.4u.sdk"
      CACHE STRING "isysroot used for universal binary support" FORCE)
  endif(OSX_TIGER_COMPAT)

  option(OSX_FAT_BINARY "Build Vidalia as a Universal binary." OFF)
  if (OSX_FAT_BINARY)
    set(CMAKE_OSX_ARCHITECTURES "ppc;i386"
        CACHE STRING "OS X build architectures" FORCE)
    set(CMAKE_EXE_LINKER_FLAGS "-mmacosx-version-min=10.4"
        CACHE STRING "Flags used by the linker." FORCE)
    set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.4u.sdk"
        CACHE STRING "isysroot used for universal binary support" FORCE)
  endif(OSX_FAT_BINARY)

  option(OSX_FORCE_32BIT "Force a 32-bit build for compatibility." OFF)
  if (OSX_FORCE_32BIT)
    add_definitions(-m32)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -m32"
        CACHE STRING "Flags used by the linker." FORCE)
  endif(OSX_FORCE_32BIT)
endif(APPLE)

## Define if compiled with Windows 2k support
option(WIN2K "Enable Windows 2k support." OFF)

## UPnP support is currently optional (enabled by default)
option(USE_MINIUPNPC "Enable UPnP support using the MiniUPnPc library." ON)

## Crash reporting via Google Breakpad is optional (disabled by default)
option(USE_BREAKPAD "Enable Google Breakpad crash reporting." OFF)
if (USE_BREAKPAD)
  include(${CMAKE_SOURCE_DIR}/cmake/FindBreakpad.cmake)
endif(USE_BREAKPAD)

## Automatic software update is optional (disabled by default)
if (WIN32)
  option(USE_AUTOUPDATE "Enable automatic software update support." OFF)
endif(WIN32)

## Find the KDE Marble library
if (USE_MARBLE)
  include(${CMAKE_SOURCE_DIR}/cmake/FindMarble.cmake)
endif(USE_MARBLE)

## Find the MaxMind GeoIP library
option(USE_GEOIP "Enable GeoIP lookups via a local MaxMind database" OFF)
if (USE_GEOIP)
  include(${CMAKE_SOURCE_DIR}/cmake/FindGeoIP.cmake)
endif(USE_GEOIP)

## Check for system header files
check_include_file("limits.h" HAVE_LIMITS_H)
check_include_file("sys/limits.h" HAVE_SYS_LIMITS_H)
check_include_file("signal.h" HAVE_SIGNAL_H)

## Check for the sizes of various data types
check_type_size(int SIZEOF_INT)

## Check for the existence of some platform-specific functions
if (HAVE_SIGNAL_H)
  set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} "signal.h")
  check_function_exists(sigaction HAVE_SIGACTION)
  check_function_exists(signal HAVE_SIGNAL)
endif(HAVE_SIGNAL_H)

## Write out a configuration file
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.h
)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

## Add the actual source directories
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(pkg)

=== doc/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##


configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/vidalia.1.in
  ${CMAKE_CURRENT_SOURCE_DIR}/vidalia.1
)

set(DOXYGEN_INPUT_DIR ${Vidalia_SOURCE_DIR})
set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR})
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
  ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
)

include(FindDoxygen)
if (DOXYGEN_FOUND)
  add_custom_target(doxygen
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
  )
endif(DOXYGEN_FOUND)

=== pkg/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##

if (APPLE)
  add_subdirectory(osx)
endif(APPLE)
if (UNIX)
  add_subdirectory(rpm)
endif(UNIX)
if (WIN32)
  add_subdirectory(win32)
endif(WIN32)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/package.sh
  ${CMAKE_CURRENT_BINARY_DIR}/package.sh
  COPYONLY
)

set(basename "vidalia-${VERSION}")
set(tarname "${basename}.tar.gz")
add_custom_target(dist
  COMMAND svn export
    ${Vidalia_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}/${basename}
  COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_CURRENT_BINARY_DIR}
    tar czf ${tarname} ${basename}/
  COMMAND ${CMAKE_COMMAND} -E copy
    ${CMAKE_CURRENT_BINARY_DIR}/${tarname} ${Vidalia_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E remove -f
    ${CMAKE_CURRENT_BINARY_DIR}/${tarname}
  COMMAND ${CMAKE_COMMAND} -E remove_directory
    ${CMAKE_CURRENT_BINARY_DIR}/${basename}
  COMMENT "Creating ${tarname}"
)

=== src/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##


include_directories(
  ${QT_INCLUDES}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/torcontrol
  ${CMAKE_CURRENT_SOURCE_DIR}/common
)
link_directories(
  ${CMAKE_CURRENT_BINARY_DIR}/torcontrol
  ${CMAKE_CURRENT_BINARY_DIR}/common
)

if(MSVC)
  add_definitions(-D_USE_MATH_DEFINES=1)
 
  ## Qt's Visual Studio builds explicitly disable treating wchar_t as a
  ## built-in type, so we need to do that as well otherwise we get linker
  ## errors due to name mangling if we try to use a wchar_t-related method
  add_definitions(/Zc:wchar_t-)

  ## Specify that we want the "W" version of Windows methods, such as
  ## CreateFileW or WriteFileW
  add_definitions(-DUNICODE=1)

  ## Disable incremental linking for all build types, not just Release
  ## and MinSizeRel
  set(CMAKE_EXE_LINKER_FLAGS_DEBUG
      "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /INCREMENTAL:NO"
  )
  set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO
      "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /INCREMENTAL:NO"
  )
endif(MSVC)

## Add some Qt definitions
if (WIN32)
  add_definitions(-DQT_THREAD_SUPPORT)
  if (NOT QT_CONFIG MATCHES "static")
    add_definitions(-DQT_DLL)
  endif(NOT QT_CONFIG MATCHES "static")
endif(WIN32)

if (USE_MINIUPNPC)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/miniupnpc)
  link_directories(${CMAKE_CURRENT_BINARY_DIR}/miniupnpc)
  add_subdirectory(miniupnpc)
endif(USE_MINIUPNPC)
if (USE_BREAKPAD)
  add_subdirectory(crashreporter)
endif(USE_BREAKPAD)

add_subdirectory(common)
add_subdirectory(tools)
add_subdirectory(torcontrol)
add_subdirectory(vidalia)

=== pkg/osx/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##


set(VIDALIA_APP_BUNDLE_ROOT ${Vidalia_BINARY_DIR}/src/vidalia/Vidalia.app)
get_target_property(VIDALIA_EXECUTABLE Vidalia LOCATION)
add_custom_target(dist-osx-libraries DEPENDS Vidalia)
if (QT_USE_FRAMEWORKS)
  vidalia_install_qt4_framework(QtCore
    TARGET dist-osx-libraries NAME QtCore
    LIBRARY ${QT_QTCORE_LIBRARY_RELEASE}/QtCore
    APP_BUNDLE ${VIDALIA_APP_BUNDLE_ROOT}
  )
  vidalia_install_qt4_framework(QtGui
    TARGET dist-osx-libraries NAME QtGui
    LIBRARY ${QT_QTGUI_LIBRARY_RELEASE}/QtGui
    APP_BUNDLE ${VIDALIA_APP_BUNDLE_ROOT}
    DEPENDS_FRAMEWORKS ${QtCore}
  )
  vidalia_install_qt4_framework(QtNetwork
    TARGET dist-osx-libraries NAME QtNetwork
    LIBRARY ${QT_QTNETWORK_LIBRARY_RELEASE}/QtNetwork
    APP_BUNDLE ${VIDALIA_APP_BUNDLE_ROOT}
    DEPENDS_FRAMEWORKS ${QtCore}
  )
  vidalia_install_qt4_framework(QtXml
    TARGET dist-osx-libraries NAME QtXml
    LIBRARY ${QT_QTXML_LIBRARY_RELEASE}/QtXml
    APP_BUNDLE ${VIDALIA_APP_BUNDLE_ROOT}
    DEPENDS_FRAMEWORKS ${QtCore}
  )
  vidalia_install_name_tool(${VIDALIA_EXECUTABLE}
    TARGET dist-osx-libraries
    FRAMEWORKS ${QtCore} ${QtGui} ${QtNetwork} ${QtXml}
  )
  if (USE_MARBLE)
    vidalia_install_qt4_framework(QtSvg
      TARGET dist-osx-libraries NAME QtSvg
      LIBRARY ${QT_QTSVG_LIBRARY_RELEASE}/QtSvg
      APP_BUNDLE ${VIDALIA_APP_BUNDLE_ROOT}
      DEPENDS_FRAMEWORKS ${QtCore} ${QtGui}
    )
    vidalia_install_qt4_framework(QtScript
      TARGET dist-osx-libraries NAME QtScript
      LIBRARY ${QT_QTSCRIPT_LIBRARY_RELEASE}/QtScript
      APP_BUNDLE ${VIDALIA_APP_BUNDLE_ROOT}
      DEPENDS_FRAMEWORKS ${QtCore}
    )
    vidalia_install_qt4_framework(QtDBus
      TARGET dist-osx-libraries NAME QtDBus
      LIBRARY ${QT_QTDBUS_LIBRARY_RELEASE}/QtDBus
      APP_BUNDLE ${VIDALIA_APP_BUNDLE_ROOT}
      DEPENDS_FRAMEWORKS ${QtCore} ${QtXml}
    )
    vidalia_install_qt4_framework(QtPhonon
      TARGET dist-osx-libraries NAME phonon
      LIBRARY ${QT_PHONON_LIBRARY_RELEASE}/phonon
      APP_BUNDLE ${VIDALIA_APP_BUNDLE_ROOT}
      DEPENDS_FRAMEWORKS ${QtCore} ${QtGui} ${QtXml} ${QtDBus}
    )
    vidalia_install_qt4_framework(QtWebKit
      TARGET dist-osx-libraries NAME QtWebKit
      LIBRARY ${QT_QTWEBKIT_LIBRARY_RELEASE}/QtWebKit
      APP_BUNDLE ${VIDALIA_APP_BUNDLE_ROOT}
      DEPENDS_FRAMEWORKS ${QtCore} ${QtGui} ${QtNetwork} ${QtXml} ${QtDBus}
                         ${QtPhonon}
    )
    vidalia_install_dylib(MarbleWidget
      TARGET dist-osx-libraries
      LIBRARY ${MARBLEWIDGET_LIBRARY}
      APP_BUNDLE ${VIDALIA_APP_BUNDLE_ROOT}
      DEPENDS_FRAMEWORKS ${QtCore} ${QtGui} ${QtNetwork} ${QtXml} ${QtSvg}
                         ${QtDBus} ${QtScript} ${QtWebKit}
    )
    vidalia_install_name_tool(${VIDALIA_EXECUTABLE}
      TARGET dist-osx-libraries
      FRAMEWORKS ${QtSvg} ${QtDBus} ${QtScript} ${QtWebKit}
      LIBRARIES ${MARBLEWIDGET_LIBRARY}
    )
  endif(USE_MARBLE)
endif(QT_USE_FRAMEWORKS)

if (OSX_FAT_BINARY)
  set(DMG_ARCH "universal")
else(OSX_FAT_BINARY)
  set(DMG_ARCH ${CMAKE_OSX_ARCHITECTURES})
endif(OSX_FAT_BINARY)

add_custom_target(dist-osx
  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/pkg-dmg
    --source ${VIDALIA_APP_BUNDLE_ROOT}
    --target ${Vidalia_BINARY_DIR}/vidalia-${VERSION}-${DMG_ARCH}.dmg
    --sourcefile --volname "Vidalia ${VERSION}"
    --icon ${Vidalia_SOURCE_DIR}/src/vidalia/res/icons/Vidalia.icns
    --symlink "/Applications:/Drag to here"
    --mkdir /.background
    --copy ${CMAKE_CURRENT_SOURCE_DIR}/background.png:/.background/
    --copy ${CMAKE_CURRENT_SOURCE_DIR}/nonbundle-ds_store:/.DS_Store
    --copy ${CMAKE_CURRENT_SOURCE_DIR}/qt.conf:/Vidalia.app/Contents/Resources/qt.conf
    --mkdir /Licenses
    --copy ${Vidalia_SOURCE_DIR}/LICENSE:/Licenses/License.txt
    --copy ${Vidalia_SOURCE_DIR}/LICENSE-GPLV2:/Licenses/License-GPLv2.txt
    --copy ${Vidalia_SOURCE_DIR}/LICENSE-GPLV3:/Licenses/License-GPLv3.txt
    --copy ${Vidalia_SOURCE_DIR}/README:/ReadMe.txt
    --copy ${Vidalia_SOURCE_DIR}/CHANGELOG:/Changes.txt
  COMMENT "Creating vidalia-${VERSION}-${DMG_ARCH}.dmg"
  VERBATIM
)
add_dependencies(dist-osx dist-osx-libraries)

if (TOR_SOURCE_DIR)
  get_filename_component(TOR_SOURCE_DIR ${TOR_SOURCE_DIR} ABSOLUTE)

  ## Determine Tor's version string used to build the .dmg filename
  vidalia_get_tor_version(TOR_VERSION "${TOR_SOURCE_DIR}/src/or/tor")
  if (TOR_VERSION)
    message(STATUS "Found Tor ${TOR_VERSION}")
  else (TOR_VERSION)
    message(FATAL_ERROR "Unable to determine version of ${TOR_SOURCE_DIR}/src/or/tor")
  endif(TOR_VERSION)

  set(bundle_DMG "vidalia-bundle-${TOR_VERSION}-${VERSION}-${DMG_ARCH}.dmg")
  add_custom_target(dist-osx-bundle
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/pkg-dmg
      --source ${VIDALIA_APP_BUNDLE_ROOT}
      --target ${Vidalia_BINARY_DIR}/${bundle_DMG}
      --sourcefile --volname "Vidalia Bundle ${VERSION}"
      --icon ${Vidalia_SOURCE_DIR}/src/vidalia/res/icons/Vidalia.icns
      --symlink "/Applications:/Drag to here"
      --mkdir /.background
      --copy ${CMAKE_CURRENT_SOURCE_DIR}/bundle-background.png:/.background/
      --copy ${CMAKE_CURRENT_SOURCE_DIR}/bundle-ds_store:/.DS_Store
      --copy ${CMAKE_CURRENT_SOURCE_DIR}/vidalia.conf.sample:/Vidalia.app/Contents/Resources/vidalia.conf
      --copy ${CMAKE_CURRENT_SOURCE_DIR}/qt.conf:/Vidalia.app/Contents/Resources/qt.conf
      --mkdir /Licenses
      --copy ${Vidalia_SOURCE_DIR}/LICENSE:/Licenses/License.txt
      --copy ${Vidalia_SOURCE_DIR}/LICENSE-GPLV2:/Licenses/License-GPLv2.txt
      --copy ${Vidalia_SOURCE_DIR}/LICENSE-GPLV3:/Licenses/License-GPLv3.txt
      --copy ${Vidalia_SOURCE_DIR}/CHANGELOG:/Changes.txt
      --copy ${TOR_SOURCE_DIR}/src/or/tor:/Vidalia.app/Contents/MacOS/
      --copy ${TOR_SOURCE_DIR}/src/tools/tor-checkkey:/Vidalia.app/Contents/MacOS/
      --copy ${TOR_SOURCE_DIR}/src/tools/tor-gencert:/Vidalia.app/Contents/MacOS/
      --copy ${TOR_SOURCE_DIR}/src/tools/tor-resolve:/Vidalia.app/Contents/MacOS/
      --copy ${TOR_SOURCE_DIR}/src/config/geoip:/Vidalia.app/share/tor/
      --copy ${TOR_SOURCE_DIR}/src/config/torrc.sample:/Vidalia.app/Contents/Resources/
    COMMENT "Creating ${bundle_DMG}"
    VERBATIM
  )
  add_dependencies(dist-osx-bundle dist-osx-libraries)

  add_custom_target(dist-osx-split-bundle
    COMMAND hdiutil segment -segmentSize 1.5m 
      -o "${Vidalia_BINARY_DIR}/split-${bundle_DMG}" "${Vidalia_BINARY_DIR}/${bundle_DMG}"
    COMMENT "Creating split-${bundle_DMG}"
    VERBATIM
  )
  add_dependencies(dist-osx-split-bundle dist-osx-bundle)
else(TOR_SOURCE_DIR)
  message("-- Skipping dist-osx-bundle build target")
  add_custom_target(dist-osx-bundle
    COMMAND ${CMAKE_COMMAND} -E echo
      "!! The dist-osx-bundle target is not configured."
    COMMAND ${CMAKE_COMMAND} -E echo
      "!! You must set the -DTOR_SOURCE_DIR CMake variable."
    COMMAND ${CMAKE_COMMAND} -E echo "!! Quitting."
  )
  add_custom_target(dist-osx-split-bundle
    COMMAND ${CMAKE_COMMAND} -E echo
      "!! The dist-osx-split-bundle target is not configured. Quitting."
    COMMAND ${CMAKE_COMMAND} -E echo
      "!! You must set the -DTOR_SOURCE_DIR CMake variable."
    COMMAND ${CMAKE_COMMAND} -E echo "!! Quitting."
  )
endif(TOR_SOURCE_DIR)

=== pkg/rpm/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##

## RPM Spec File
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/vidalia.spec.in
  ${CMAKE_CURRENT_BINARY_DIR}/vidalia.spec
)

=== pkg/win32/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##

if (MINGW)
  if (NOT MINGW_BINARY_DIR)
    set(MINGW_BINARY_DIR ${Vidalia_BINARY_DIR}/bin)
  endif(NOT MINGW_BINARY_DIR)
endif(MINGW)

## Only configure the bundle installer if paths to Tor, Polipo, and
## Torbutton are specified 
set(CONFIGURE_BUNDLE_NSI TRUE)
if (NOT TOR_PACKAGE_DIR)
  set(CONFIGURE_BUNDLE_NSI FALSE)
endif(NOT TOR_PACKAGE_DIR)
if (NOT POLIPO_PACKAGE_DIR)
  set(CONFIGURE_BUNDLE_NSI FALSE)
endif(NOT POLIPO_PACKAGE_DIR)
if (NOT TORBUTTON_PACKAGE_DIR)
  set(CONFIGURE_BUNDLE_NSI FALSE)
endif(NOT TORBUTTON_PACKAGE_DIR)

## Windows Packages
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/vidalia.wxs.in
  ${CMAKE_CURRENT_BINARY_DIR}/vidalia.wxs
  @ONLY
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/polipo.wxs.in
  ${CMAKE_CURRENT_BINARY_DIR}/polipo.wxs
  @ONLY
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/thandy.wxs.in
  ${CMAKE_CURRENT_BINARY_DIR}/thandy.wxs
  @ONLY
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/torbutton.wxs.in
  ${CMAKE_CURRENT_BINARY_DIR}/torbutton.wxs
  @ONLY
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/tor.wxs.in
  ${CMAKE_CURRENT_BINARY_DIR}/tor.wxs
  @ONLY
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/WixUI_Custom.wxs
  ${CMAKE_CURRENT_BINARY_DIR}/WixUI_Custom.wxs
  COPYONLY
)

if (CONFIGURE_BUNDLE_NSI) 
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/vidalia-bundle.nsi.in
    ${CMAKE_CURRENT_BINARY_DIR}/vidalia-bundle.nsi
    @ONLY
  )
else(CONFIGURE_BUNDLE_NSI)
  message(STATUS "Skipping vidalia-bundle.nsi.in")
endif(CONFIGURE_BUNDLE_NSI)

## Convert the .po files to NSIS .nsh files at build time
vidalia_add_nsh(vidalia_NSH
  po/cs/vidalia_cs.po  CZECH     ISO-8859-2)
vidalia_add_nsh(vidalia_NSH
  po/de/vidalia_de.po  GERMAN    ISO-8859-1)
vidalia_add_nsh(vidalia_NSH
  po/en/vidalia_en.po  ENGLISH   ISO-8859-1)
vidalia_add_nsh(vidalia_NSH
  po/es/vidalia_es.po  SPANISH   ISO-8859-1)
vidalia_add_nsh(vidalia_NSH
  po/fa/vidalia_fa.po  FARSI     ISO-8859-6)
vidalia_add_nsh(vidalia_NSH
  po/fi/vidalia_fi.po  FINNISH   ISO-8859-1)
vidalia_add_nsh(vidalia_NSH
  po/fr/vidalia_fr.po  FRENCH    ISO-8859-1)
vidalia_add_nsh(vidalia_NSH
  po/he/vidalia_he.po  HEBREW    ISO-8859-8)
vidalia_add_nsh(vidalia_NSH
  po/it/vidalia_it.po  ITALIAN   ISO-8859-1)
vidalia_add_nsh(vidalia_NSH
  po/nl/vidalia_nl.po  DUTCH     ISO-8859-1)
vidalia_add_nsh(vidalia_NSH
  po/pl/vidalia_pl.po  POLISH    ISO-8859-2)
vidalia_add_nsh(vidalia_NSH
  po/pt/vidalia_pt.po  PORTUGUESE  ISO-8859-1)
vidalia_add_nsh(vidalia_NSH
  po/ro/vidalia_ro.po  ROMANIAN  ISO-8859-2)
vidalia_add_nsh(vidalia_NSH
  po/ru/vidalia_ru.po  RUSSIAN   Windows-1251)
vidalia_add_nsh(vidalia_NSH
  po/sv/vidalia_sv.po  SWEDISH   ISO-8859-1)
#vidalia_add_nsh(vidalia_NSH
#  zh_CN/vidalia_zh_CN.po  SIMPCHINESE   GB18030)
#vidalia_add_nsh(vidalia_NSH
#  zh_TW/vidalia_ZH_TW.po  TRADCHINESE   GB18030)

add_custom_target(i18n-win32-installer DEPENDS ${vidalia_NSH})

## Convert the .po files to WiX .wxl files at build time
vidalia_add_wxl(vidalia_WXL
  po/cs/vidalia_cs.po  cs    ISO-8859-2)
vidalia_add_wxl(vidalia_WXL
  po/de/vidalia_de.po  de    ISO-8859-1)
vidalia_add_wxl(vidalia_WXL
  po/en/vidalia_en.po  en   ISO-8859-1)
vidalia_add_wxl(vidalia_WXL
  po/es/vidalia_es.po  es   ISO-8859-1)
vidalia_add_wxl(vidalia_WXL
  po/fa/vidalia_fa.po  fa     ISO-8859-6)
vidalia_add_wxl(vidalia_WXL
  po/fi/vidalia_fi.po  fi   ISO-8859-1)
vidalia_add_wxl(vidalia_WXL
  po/fr/vidalia_fr.po  fr    ISO-8859-1)
vidalia_add_wxl(vidalia_WXL
  po/he/vidalia_he.po  he    ISO-8859-8)
vidalia_add_wxl(vidalia_WXL
  po/it/vidalia_it.po  it   ISO-8859-1)
vidalia_add_wxl(vidalia_WXL
  po/nl/vidalia_nl.po  nl     ISO-8859-1)
vidalia_add_wxl(vidalia_WXL
  po/pl/vidalia_pl.po  pl    ISO-8859-2)
vidalia_add_wxl(vidalia_WXL
  po/pt/vidalia_pt.po  pt  ISO-8859-1)
vidalia_add_wxl(vidalia_WXL
  po/ro/vidalia_ro.po  ro  ISO-8859-2)
vidalia_add_wxl(vidalia_WXL
  po/ru/vidalia_ru.po  ru   1251)
vidalia_add_wxl(vidalia_WXL
  po/sv/vidalia_sv.po  sv   ISO-8859-1)
vidalia_add_wxl(vidalia_WXL
  po/zh_CN/vidalia_zh_CN.po  zh-CN   936)
vidalia_add_wxl(vidalia_WXL
  po/zh_TW/vidalia_ZH_TW.po  zh-TW   950)

add_custom_target(dist-win32
  COMMAND ${WIX_CANDLE_EXECUTABLE} 
      ${CMAKE_CURRENT_BINARY_DIR}/vidalia.wxs 
      -o ${CMAKE_CURRENT_BINARY_DIR}/vidalia.wixobj

  COMMAND ${WIX_CANDLE_EXECUTABLE}
      ${CMAKE_CURRENT_BINARY_DIR}/WixUI_Custom.wxs
      -o ${CMAKE_CURRENT_BINARY_DIR}/WixUI_Custom.wixobj

  COMMAND ${WIX_LIGHT_EXECUTABLE}
      ${CMAKE_CURRENT_BINARY_DIR}/vidalia.wixobj
      ${CMAKE_CURRENT_BINARY_DIR}/WixUI_Custom.wixobj
      -o ${Vidalia_BINARY_DIR}/vidalia-${VERSION}.msi
      -ext ${WIX_BINARY_DIR}/WixUIExtension.dll
  
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vidalia.wxs 
          ${CMAKE_CURRENT_SOURCE_DIR}/WixUI_Custom.wxs
          ${vidalia_WXL}

  COMMENT "Building vidalia-${VERSION}.msi"
)

=== src/common/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##


set(common_SRCS
  crypto.cpp
  file.cpp
  html.cpp
  Log.cpp
  net.cpp
  procutil.cpp
  stringutil.cpp
  TorSocket.cpp
)
qt4_wrap_cpp(common_SRCS 
  TorSocket.h
)

if(WIN32)
  set(common_SRCS ${common_SRCS}
    win32.cpp
  )
endif(WIN32)

add_library(common STATIC ${common_SRCS})
target_link_libraries(common
  ${QT_QTCORE_LIBRARY}
  ${QT_QTNETWORK_LIBRARY}
)

if (WIN32 AND QT_CONFIG MATCHES "static")
  target_link_libraries(common z)
endif(WIN32 AND QT_CONFIG MATCHES "static")

=== src/crashreporter/CMakeLists.txt ===
##
##  $Id$
##
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${BREAKPAD_INCLUDE_DIR}
)

## Add the application source files
set(crashreporter_SRCS
  main.cpp
  CrashReportDialog.cpp
)
qt4_wrap_cpp(crashreporter_SRCS
  CrashReportDialog.h
)
qt4_wrap_ui(crashreporter_SRCS
  CrashReportDialog.ui
)
qt4_add_resources(crashreporter_SRCS
  res/CrashReporter.qrc
)
if (MSVC)
  configure_file(
    res/CrashReporter.rc.in
    ${CMAKE_CURRENT_BINARY_DIR}/CrashReporter.rc
  )
  set(crashreporter_SRCS
    ${crashreporter_SRCS}
    ${CMAKE_CURRENT_BINARY_DIR}/CrashReporter.rc
  )
endif(MSVC)

## Create the crashreporter executable
if (WIN32)  
  add_executable(crashreporter WIN32 ${crashreporter_SRCS})
else(WIN32)
  add_executable(crashreporter ${crashreporter_SRCS})
endif(WIN32)

## Link the crash reporter application with the Qt and Breakpad libraries
target_link_libraries(crashreporter
  ${QT_QTCORE_LIBRARY}
  ${QT_QTGUI_LIBRARY}
  ${QT_QTNETWORK_LIBRARY}
  ${BREAKPAD_LIBRARY}
  common
)
if (WIN32)
  target_link_libraries(crashreporter
    ${QT_QTMAIN_LIBRARY}
  )
endif(WIN32)

## Remember the location of the crash reporter binary so we can use it in 
## the Windows packaging scripts
get_target_property(CRASHREPORTER_EXECUTABLE crashreporter LOCATION_RelWithDebInfo)
set(VIDALIA_CRASHREPORTER_EXECUTABLE ${CRASHREPORTER_EXECUTABLE}
    CACHE STRING "Location of Vidalia's crash reporting application." FORCE)

=== src/miniupnpc/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##

add_definitions(-DSTATICLIB -DNDEBUG)

set(miniupnpc_SRCS
  igd_desc_parse.c
  minisoap.c
  miniupnpc.c
  miniwget.c
  minixml.c
  upnpcommands.c
  upnperrors.c
  upnpreplyparse.c
  connecthostport.c
)
if (NOT WIN32)
  set(miniupnpc_SRCS ${miniupnpc_SRCS} minissdpc.c)
endif(NOT WIN32)

add_library(miniupnpc STATIC ${miniupnpc_SRCS})
if (WIN32)
  add_definitions(-D_WIN32_WINNT=0x0501)
  target_link_libraries(miniupnpc ws2_32)
endif(WIN32)

=== src/tools/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##

add_subdirectory(ts2po)
add_subdirectory(po2ts)

if (WIN32)
  add_subdirectory(po2nsh)
  add_subdirectory(nsh2po EXCLUDE_FROM_ALL)
  add_subdirectory(po2wxl)
  add_subdirectory(wixtool)
endif(WIN32)

=== src/torcontrol/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.torproject.org/projects/vidalia.html. No part of Vidalia, 
##  including this file, may be copied, modified, propagated, or distributed 
##  except according to the terms described in the LICENSE file.
##


set(torcontrol_SRCS 
  AddressMap.cpp
  BootstrapStatus.cpp
  Circuit.cpp
  ControlCommand.cpp
  ControlConnection.cpp
  ControlReply.cpp
  ControlSocket.cpp
  ControlMethod.cpp
  ProtocolInfo.cpp
  ReplyLine.cpp
  RouterDescriptor.cpp
  RouterStatus.cpp
  SendCommandEvent.cpp
  Stream.cpp
  tcglobal.cpp
  TorControl.cpp
  TorEvents.cpp
  TorProcess.cpp
  TorSignal.cpp
)
qt4_wrap_cpp(torcontrol_SRCS
  ControlConnection.h
  ControlSocket.h
  TorControl.h
  TorEvents.h
  TorProcess.h
)

if (WIN32)
  set(torcontrol_SRCS ${torcontrol_SRCS} 
    TorService.cpp
  )
  qt4_wrap_cpp(torcontrol_SRCS
    TorService.h
  )
endif(WIN32)


add_library(torcontrol STATIC  ${torcontrol_SRCS})
target_link_libraries(torcontrol
  ${QT_QTCORE_LIBRARY}
  ${QT_QTNETWORK_LIBRARY}
  common
)

=== debian/changelog ===
vidalia (0.2.21-1) unstable; urgency=low

  [ Ulises Vitulli ]
  * Un-hold locked new upstream release: fixes several bugs:
    - Avoid waiting to reload router list if ns/all returned empty.
    - Stop trying to load router information if torControl is not connected.
    - Fix RouterDescriptor's bandwidth and uptime values when defined from the
      consensus.
    - Save ControlPortWriteToFile using relative path.
  * Updated Debconf template translations:
    - Italian, thanks Fabio Pirola (Closes: #699082).
  * Updated Standard-version to 3.9.4 (no changes needed).

  [ intrigeri ]
  * Drop the patches that were taken from upstream 0.2.21:
    - Fix-wrong-uptime-bandwidth-in-relay-list.patch
    - Populate-the-relay-list-at-startup.patch

 -- Ulises Vitulli <dererk@debian.org>  Sat, 11 May 2013 11:07:13 -0300

=== debian/control ===
Source: vidalia
Section: net
Priority: extra
Maintainer: Ulises Vitulli <dererk@debian.org>
Uploaders: Vern Sun <s5unty@gmail.com>, intrigeri <intrigeri@debian.org>
Build-Depends: debhelper (>= 6.0.7~), dh-apparmor, autotools-dev, libqt4-dev (>= 4.1.0), po-debconf (>= 1.0), cmake (>= 2.4.8), libssl-dev (>= 0.9.8g), dpkg-dev (>= 1.16.1.1~)
Standards-Version: 3.9.4
Homepage: https://www.torproject.org/projects/vidalia
Vcs-Git: git://git.debian.org/collab-maint/vidalia.git/
Vcs-Browser: http://git.debian.org/?p=collab-maint/vidalia.git

Package: vidalia
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>=1.5.11) | debconf-2.0,
 ucf, adduser, tor (>= 0.2.2.29-beta-1)
Suggests: iceweasel-torbutton, apparmor
Description: controller GUI for Tor
 Vidalia offers a graphical user interface to start and stop Tor, view
 its status at a glance, and monitor its bandwidth usage.
 .
 Vidalia also makes it easy to contribute to
 the Tor network by helping you set up a Tor server.
 .
 Tor protects privacy in communications via a distributed network of
 relays run by volunteers all around the world: it prevents anybody
 watching Internet connections from learning what sites you visit,
 and it prevents the visited sites from learning your physical
 location. Tor works with web browsers, instant messaging programs,
 remote login clients, and many other TCP-based applications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS += -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp
	
build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	dh_testdir
	mkdir -p debian/build;
	cd debian/build; \
		cmake -DCMAKE_INSTALL_PREFIX=/usr \
			-DQT_LRELEASE_EXECUTABLE=/usr/bin/lrelease-qt4 \
			-QT_LUPDATE_EXECUTABLE=/usr/bin/lupdate-qt4 ../.. ;\
		make
	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp CMakeCache.txt doc/Doxyfile \
		doc/vidalia.1 src/vidalia/res/vidalia_win.rc 
	rm -rf debian/build CMakeFiles
	for f in src/vidalia/i18n/*.qm; do\
		rm -rf $$f; \
	done
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs 
	cp debian/apparmor-profile debian/vidalia/etc/apparmor.d/usr.bin.vidalia
	dh_apparmor --profile-name=usr.bin.vidalia -pvidalia
	# Install the package
	cd debian/build; \
		make install DESTDIR=$(CURDIR)/debian/vidalia

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_install
	dh_installdocs
	dh_installchangelogs CHANGELOG
	dh_installman doc/vidalia.1
	dh_installdebconf
	dh_installmenu
	dh_link
	dh_strip
	dh_lintian
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
# avoid evaluating development releases (0.2.x branches)
opts=uversionmangle=s/0\.2\./~pre/ \
	https://www.torproject.org/dist/vidalia/vidalia-(.*)\.tar\.gz
